function varargout = advc(varargin)
% ADVC M-file for advc.fig
%      ADVC, by itself, creates a new ADVC or raises the existing
%      singleton*.
%
%      H = ADVC returns the handle to a new ADVC or the handle to
%      the existing singleton*.
%
%      ADVC('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ADVC.M with the given input arguments.
%
%      ADVC('Property','Value',...) creates a new ADVC or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before advc_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to advc_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help advc

% Last Modified by GUIDE v2.5 18-May-2011 11:47:29

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @advc_OpeningFcn, ...
                   'gui_OutputFcn',  @advc_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before advc is made visible.
function advc_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to advc (see VARARGIN)

% Choose default command line output for advc
handles.output = hObject;

input_var_A = varargin{1};
input_var_Aeq = varargin{2};
input_var_Atot = varargin{3};
input_var_b = varargin{4};
input_var_beq = varargin{5};
input_var_btot = varargin{6};

input_var_Q = varargin{7};
input_var_r = varargin{8};
input_var_c = varargin{9};
input_ineqs = varargin{10};

data = varargin{11};


handles.mode = 'nowhere';
handles.type = 0;

handles.n = 0;

handles.var_A = input_var_A;
handles.var_Aeq = input_var_Aeq;
handles.var_Atot = input_var_Atot;
handles.var_b = input_var_b;
handles.var_beq = input_var_beq;
handles.var_btot = input_var_btot;

handles.var_Q = input_var_Q;
handles.var_r = input_var_r;
handles.var_c = input_var_c;
handles.ineqs = input_ineqs;

if ~isempty(input_var_A)
    set(handles.constr_type_popupmenu,'Value',2);
    set(handles.define_button,'Enable','On');
    set(handles.constr_grad_check,'Enable','Off');
elseif ~isempty(input_var_Q)
    set(handles.constr_type_popupmenu,'Value',3);
    set(handles.define_button,'Enable','On');
else
    set(handles.constr_type_popupmenu,'Value',1);
    set(handles.define_button,'Enable','Off');
end

set(handles.obj_check,'Value',data.obj_strict);
set(handles.grad_check,'Value',data.obj_grad);
set(handles.constr_grad_check,'Value',data.constr_grad);
set(handles.constr_check,'Value',data.constr);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes advc wait for user response (see UIRESUME)
uiwait(handles.advc);


% --- Outputs from this function are returned to the command line.
function varargout = advc_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
switch handles.mode
    case 'ok'
        %output = getappdata(handles.lin_obj,'output');
        output.type = handles.type;
        output.data = handles.data;
        switch handles.type
            case 2
                output.var_A = handles.var_A;
                output.var_Aeq = handles.var_Aeq;
                output.var_Atot = handles.var_Atot;
                output.var_b = handles.var_b;
                output.var_beq = handles.var_beq;
                output.var_btot = handles.var_btot;
                output.n = length(handles.var_btot);
            case 3
                output.var_Q = handles.var_Q;
                output.var_r = handles.var_r;
                output.var_c = handles.var_c;
                output.ineqs = handles.ineqs;
                output.n = length(handles.var_c);
            otherwise
        end
        varargout{1} = output;
        close
    case 'cancel'
        varargout{1} = 1;
        close
    otherwise
    uiwait(handles.advc);
end


function cancel_button_Callback(hObject, eventdata, handles)
handles.mode = 'cancel';
guidata(hObject, handles);
uiresume


function ok_button_Callback(hObject, eventdata, handles)
if handles.type ~= -1
    if get(handles.constr_type_popupmenu,'Value') == 1
        handles.type = -1;
    elseif (~isempty(handles.var_A) || ~isempty(handles.var_Aeq))
        handles.type = 2;
    elseif ~isempty(handles.var_Q)
        handles.type = 3;
    end
end

data.obj_strict = get(handles.obj_check,'Value');
data.obj_grad = get(handles.grad_check,'Value');
data.constr_grad = get(handles.constr_grad_check,'Value');
data.constr = get(handles.constr_check,'Value');

handles.data = data;

handles.mode = 'ok';
guidata(hObject, handles);
uiresume


function constr_type_popupmenu_Callback(hObject, eventdata, handles)
    if get(hObject,'Value') == 1
        set(handles.define_button,'Enable','Off');
    else
        set(handles.define_button,'Enable','On');
    end
guidata(hObject, handles);


function constr_type_popupmenu_CreateFcn(hObject, eventdata, handles)

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function define_button_Callback(hObject, eventdata, handles)
    handles.type = get(handles.constr_type_popupmenu,'Value');
    switch handles.type
        case 2
            set(hObject,'Enable','Off');
            output = lin_constr(handles.var_A, handles.var_Aeq, handles.var_b, handles.var_beq);
            set(hObject,'Enable','On');
            
            var_A = [];
            var_Aeq = [];
            try
                var_A = output.var_A;
                var_Aeq = output.var_Aeq;
            catch exception
            end

            if isempty(var_A) && isempty(var_Aeq)
                if output == 1
                    handles.type = 0;
                else
                    handles.type = -1;
                    set(handles.constr_grad_check,'Enable','On');
                end
            else
                handles.var_A = var_A;
                handles.var_Aeq = var_Aeq;
                handles.var_Atot = output.var_Atot;
                handles.var_b = output.var_b;
                handles.var_beq = output.var_beq;
                handles.var_btot = output.var_btot;
                handles.n = output.n;
                set(handles.constr_grad_check,'Value',1);
                set(handles.constr_grad_check,'Enable','Off');
            end
            
        case 3
            set(hObject,'Enable','Off');
            output = quad_constr(handles.var_Q, handles.var_r, handles.var_c, handles.ineqs);
            set(hObject,'Enable','On');
            
            var_Q = [];
            try
                var_Q = output.var_Q;
            catch exception
            end

            if isempty(var_Q)
                if output == 1
                    handles.type = 0;
                else
                    handles.type = -1;
                end
            else
                handles.var_Q = var_Q;
                handles.var_r = output.var_r;
                handles.var_c = output.var_c;
                handles.ineqs = output.ineqs;
                handles.n = output.n;
            end
        otherwise
    end
guidata(hObject, handles);


function default_button_Callback(hObject, eventdata, handles)
    handles.type = -1;
    
    handles.var_A = [];
    handles.var_Aeq = [];
    handles.var_Atot = [];
    handles.var_b = [];
    handles.var_beq = [];
    handles.var_btot = [];
    handles.n = 0;
    
    handles.var_Q = [];
    handles.var_r = [];
    handles.var_c = [];
    handles.ineqs = [];
    
    set(handles.obj_check,'Value',0);
    set(handles.grad_check,'Value',0);
    set(handles.constr_check,'Value',0);
    set(handles.constr_grad_check,'Value',0);
    set(handles.constr_grad_check,'Enable','On');
    
    set(handles.constr_type_popupmenu,'Value',1);
    set(handles.define_button,'Enable','Off');
guidata(hObject, handles);    


function advc_CloseRequestFcn(hObject, eventdata, handles)

%%%CloseReqFCN
if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    handles.mode = 'cancel';
    guidata(hObject, handles);
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end


function obj_check_Callback(hObject, eventdata, handles)


function grad_check_Callback(hObject, eventdata, handles)


function constr_check_Callback(hObject, eventdata, handles)


function constr_grad_check_Callback(hObject, eventdata, handles)
