function [d,itrs,funcs] = delta_large(fhandle,lb,ub)
    tot_itr = 0;
    func_count = 0;
    n = length(lb);
    d_ = -Inf;
    
    options = optimset('Algorithm','active-set');
    for j = 1:n,
        x0 = lb;
        if (lb(1,j) == 0)
            x0 = ub;
        end
        [~,~, d_new,~,output] = evalc('fmincon(@(x) -func_ij(fhandle,x,1,j), x0, [], [], [], [], lb, ub, [], options)');
        if output.iterations ~= 0
            tot_itr = tot_itr + output.iterations;
        else
            tot_itr = tot_itr + 1;
        end
        func_count = func_count + output.funcCount;
        if (-d_new > d_)
            d_ = -d_new;
        end
    end
    d = d_;
    itrs = tot_itr;
    funcs = func_count;
end