function varargout = exponent_obj(varargin)
% EXPONENT_OBJ M-file for exponent_obj.fig
%      EXPONENT_OBJ, by itself, creates a new EXPONENT_OBJ or raises the existing
%      singleton*.
%
%      H = EXPONENT_OBJ returns the handle to a new EXPONENT_OBJ or the handle to
%      the existing singleton*.
%
%      EXPONENT_OBJ('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EXPONENT_OBJ.M with the given input arguments.
%
%      EXPONENT_OBJ('Property','Value',...) creates a new EXPONENT_OBJ or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before exponent_obj_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to exponent_obj_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help exponent_obj

% Last Modified by GUIDE v2.5 08-May-2011 17:16:17

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @exponent_obj_OpeningFcn, ...
                   'gui_OutputFcn',  @exponent_obj_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before exponent_obj is made visible.
function exponent_obj_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to exponent_obj (see VARARGIN)

% Choose default command line output for exponent_obj
handles.output = hObject;

input_form = varargin{1};
input_coeffs_a = varargin{2};
input_coeffs_b = varargin{3};
if ~isempty(input_coeffs_a)
    set(handles.coeffs_a_edit,'String',vector2str(input_coeffs_a));
    set(handles.coeffs_b_edit,'String',vector2str(input_coeffs_b));
end

handles.mode = 'nowhere';
handles.form_std = input_form;
handles.coefficients = input_coeffs_a;
handles.coeffs_matrix = [];
handles.coeffs_exp = input_coeffs_b;
handles.pos_idx = [];
handles.neg_idx = [];
handles.indexes = [];
handles.exponent = 1;
handles.uniform = 0;

% Update handles structure
guidata(hObject, handles);
%setappdata(handles.figure1, 'output',1);
% UIWAIT makes exponent_obj wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = exponent_obj_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
switch handles.mode
    case 'ok'
        coeffs_a = handles.coefficients;
        output.coefficients = coeffs_a;
        output.coeffs_matrix = handles.coeffs_matrix;
        output.coeffs_exp = handles.coeffs_exp;
        output.exponent = handles.exponent;
        output.indexes = handles.indexes;
        output.pos_idx = handles.pos_idx;
        output.neg_idx = handles.neg_idx;
        output.n = length(coeffs_a);
        output.m = 1;
        output.uniform = handles.uniform;
        varargout{1} = output;
        close
    case 'reset'
        varargout{1} = 2;
        close
    case 'cancel'
        varargout{1} = 1;
        close
        %error('You have quit!!'); This works, but also gives a bunch of
        %other errors. It's better if it is put in the calling function for
        %when output equals 1.
    otherwise
    uiwait(handles.figure1);
end


function coeffs_b_edit_Callback(hObject, eventdata, handles)


function coeffs_b_edit_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function status_text_Callback(hObject, eventdata, handles)


function status_text_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function cancel_button_Callback(hObject, eventdata, handles)
handles.mode = 'cancel';
guidata(hObject, handles);
uiresume


function ok_button_Callback(hObject, eventdata, handles)
err_ = 0;
err_msg = '';
noclose = 1;
input_a = get(handles.coeffs_a_edit,'String');
input_b = get(handles.coeffs_b_edit,'String');

if ~isempty(input_a) || ~isempty(input_b)
    [err_,err_msg,coeffs_a] = test_vector_input(input_a,0,'a');

    if ~err_
        [err_,err_msg,coeffs_b] = test_vector_input(input_b,0,'b');
    end

    % Perform checks on data
    if ~err_
        n = length(coeffs_a);
        if length(coeffs_b) ~= n
            err_ = 1;
            err_msg = 'Error: The dimensions of vector a and vector b does not match.';
        end
        
        if ~err_
            msg_std = 'Error: In order to have a strictly increasing function, each ai and bi must both be either positive or negative.';
            msg_can = 'Error: In order to have a strictly decreasing function, each ai and bi must have opposite signs.';
            for i = 1:n,
                if handles.form_std
                    if coeffs_a(i) == 0 || coeffs_b(i) == 0
                        err_ = 1;
                        err_msg = 'Error: All elements of the vectors a and b must be non-zero.';
                    elseif coeffs_a(i) > 0 && coeffs_b(i) < 0
                        err_ = 1;
                        err_msg = msg_std;
                    elseif coeffs_a(i) < 0 && coeffs_b(i) > 0
                        err_ = 1;
                        err_msg = msg_std;
                    end
                else
                    if coeffs_a(i) == 0 || coeffs_b(i) == 0
                        err_ = 1;
                        err_msg = 'Error: All elements of the vectors a and b must be non-zero.';
                    elseif coeffs_a(i) > 0 && coeffs_b(i) > 0
                        err_ = 1;
                        err_msg = msg_can;
                    elseif coeffs_a(i) < 0 && coeffs_b(i) < 0
                        err_ = 1;
                        err_msg = msg_can;
                    end
                end
            end
        end
    end

    if err_
        noclose = 0;
        set(handles.status_text,'String',err_msg);
    else
        handles.coefficients = coeffs_a;
        handles.coeffs_exp = coeffs_b;
        handles.pos_idx = 1:n;
        handles.neg_idx = [];
    end
    
    handles.mode = 'ok';
else
    if ~isempty(handles.coefficients)
        handles.mode = 'reset';
    else
        handles.mode = 'cancel';
    end
end

guidata(hObject, handles);
% only close if neccessary (the close command is in the Output Function)
if noclose
uiresume
end


function coeffs_a_edit_Callback(hObject, eventdata, handles)
    

function coeffs_a_edit_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function figure1_CloseRequestFcn(hObject, eventdata, handles)

%%%CloseReqFCN
if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    handles.mode = 'cancel';
    guidata(hObject, handles);
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end
