function [sol,x,y,done] = flipdistrlin_canonical(A,b,x_0,lb,ub,ac)
    try
    if nargin == 5
        ac = 1e-6;
    end
    n = length(x_0);
    gamma = gammas_linear(A);
    x_it = x_0;
    x_new = zeros(1,n);
    values = zeros(n,1);
    values(1:n,1) = x_0;
    counter = 1;
    done = 0;
    
    while (~done && counter <= 1000),
        converged = 0;
        for i = 1:n,
            x_new(i) = x_it(i) - gamma(i)*(A(i,:)*x_it' + b(i));
            if (x_new(i) < lb(i))
                x_new(i) = lb(i);
            elseif (x_new(i) > ub(i))
                x_new(i) = ub(i);
            end
            
            if (abs(x_new(i) - x_it(i)) <= ac)
                converged = converged + 1;
            end
        end
        
        x_it = x_new;
        counter = counter + 1;
        values(1:n,counter) = x_new;
        if (converged == n), done = 1; end
    end
    x = 0:counter-1;
    y = values;
    sol = x_new;
    catch exception
        sol = 0;
        x = 0;
        y = 0;
        done = 0;
        disp(exception.message);
    end
end