function varargout = linear_obj(varargin)
% LINEAR_OBJ M-file for linear_obj.fig
%      LINEAR_OBJ, by itself, creates a new LINEAR_OBJ or raises the existing
%      singleton*.
%
%      H = LINEAR_OBJ returns the handle to a new LINEAR_OBJ or the handle to
%      the existing singleton*.
%
%      LINEAR_OBJ('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LINEAR_OBJ.M with the given input arguments.
%
%      LINEAR_OBJ('Property','Value',...) creates a new LINEAR_OBJ or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before linear_obj_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to linear_obj_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help linear_obj

% Last Modified by GUIDE v2.5 18-Apr-2011 11:35:43

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @linear_obj_OpeningFcn, ...
                   'gui_OutputFcn',  @linear_obj_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before linear_obj is made visible.
function linear_obj_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to linear_obj (see VARARGIN)

% Choose default command line output for linear_obj
handles.output = hObject;

input_form = varargin{1};
input_coeffs = varargin{2};
if ~isempty(input_coeffs)
    set(handles.coeffs_edit,'String',vector2str(input_coeffs));
end

handles.mode = 'nowhere';
handles.form_std = input_form;
handles.coefficients = input_coeffs;
handles.coeffs_matrix = [];
handles.coeffs_exp = [];
handles.pos_idx = [];
handles.neg_idx = [];
handles.indexes = [];
handles.exponent = 1;
handles.uniform = 0;

% Update handles structure
guidata(hObject, handles);
%setappdata(handles.lin_obj, 'output',1);
% UIWAIT makes linear_obj wait for user response (see UIRESUME)
uiwait(handles.lin_obj);


% --- Outputs from this function are returned to the command line.
function varargout = linear_obj_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
switch handles.mode
    case 'ok'
        coeffs = handles.coefficients;
        output.coefficients = coeffs;
        output.coeffs_matrix = handles.coeffs_matrix;
        output.coeffs_exp = handles.coeffs_exp;
        output.exponent = handles.exponent;
        output.indexes = handles.indexes;
        output.pos_idx = handles.pos_idx;
        output.neg_idx = handles.neg_idx;
        output.n = length(coeffs);
        output.m = 1;
        output.uniform = handles.uniform;
        varargout{1} = output;
        close
    case 'reset'
        varargout{1} = 2;
        close
    case 'cancel'
        varargout{1} = 1;
        close
    otherwise
    uiwait(handles.lin_obj);
end


function coeffs_edit_Callback(hObject, eventdata, handles)


function coeffs_edit_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function status_text_Callback(hObject, eventdata, handles)


function status_text_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function cancel_button_Callback(hObject, eventdata, handles)
handles.mode = 'cancel';
guidata(hObject, handles);
uiresume


function ok_button_Callback(hObject, eventdata, handles)
err_ = 0;
err_msg = '';
noclose = 1;
uniform = 1;
input = get(handles.coeffs_edit,'String');

if ~isempty(input)
    [err_,err_msg,coeffs] = test_vector_input(input,0,'Coefficients');

    % Perform checks on data
    if ~err_
        n = length(coeffs);
        value = coeffs(1);
        for i = 1:n,
            if value ~= coeffs(i), uniform = 0; end
            if handles.form_std
                if (coeffs(i) <= 0)
                    err_ = 1;
                    err_msg = 'Error: All coefficients must be larger than zero such that the objective function is strictly increasing';
                    break;
                end
            else
                if (coeffs(i) >= 0)
                    err_ = 1;
                    err_msg = 'Error: All coefficients must be less than zero such that the objective function is strictly decreasing';
                    break;
                end
            end
        end
    end

    if err_
        noclose = 0;
        set(handles.status_text,'String',err_msg);
    else
        handles.coefficients = coeffs;
        handles.uniform = uniform;
    end
    
    handles.mode = 'ok';
else
    if ~isempty(handles.coefficients)
        handles.mode = 'reset';
    else
        handles.mode = 'cancel';
    end
end

guidata(hObject, handles);
% only close if neccessary (the close command is in the Output Function)
if noclose
uiresume
end


function lin_obj_CloseRequestFcn(hObject, eventdata, handles)

%%%CloseReqFCN
if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    handles.mode = 'cancel';
    guidata(hObject, handles);
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end
