function varargout = quad_constr(varargin)
% QUAD_CONSTR M-file for quad_constr.fig
%      QUAD_CONSTR, by itself, creates a new QUAD_CONSTR or raises the existing
%      singleton*.
%
%      H = QUAD_CONSTR returns the handle to a new QUAD_CONSTR or the handle to
%      the existing singleton*.
%
%      QUAD_CONSTR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in QUAD_CONSTR.M with the given input arguments.
%
%      QUAD_CONSTR('Property','Value',...) creates a new QUAD_CONSTR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before quad_constr_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to quad_constr_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help quad_constr

% Last Modified by GUIDE v2.5 19-Apr-2011 11:12:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @quad_constr_OpeningFcn, ...
                   'gui_OutputFcn',  @quad_constr_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before quad_constr is made visible.
function quad_constr_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to quad_constr (see VARARGIN)

% Choose default command line output for quad_constr
handles.output = hObject;

handles.var_Q = [];
handles.var_r = [];
handles.var_c = [];
handles.ineqs = [];
handles.n_constr = 0;
handles.ineqeq = 1;

input_var_Q = varargin{1};
input_var_r = varargin{2};
input_var_c = varargin{3};
input_ineqs = varargin{4};

if ~isempty(input_var_Q)
    handles.var_Q = input_var_Q;
    handles.var_r = input_var_r;
    handles.var_c = input_var_c;
    handles.ineqs = input_ineqs;
    handles.n_constr = length(input_ineqs);
    
    set(handles.Q_edit,'String',matrix2str(input_var_Q(:,:,1)));
    set(handles.r_edit,'String',vector2str(input_var_r(1,:)));
    set(handles.c_edit,'String',sprintf('%.3f',handles.var_c(1)));
    if input_ineqs(1)
        set(handles.ineq_group,'SelectedObject',handles.inequality_radio);
        handles.ineqeq = 1;
    else
        set(handles.ineq_group,'SelectedObject',handles.equality_radio);
        handles.ineqeq = 0;
    end
end

handles.mode = 'nowhere';
handles.counter = 1;

set(handles.nr_text,'String',sprintf('Constraint nr: %i',handles.counter));

set(handles.ineq_group,'SelectionChangeFcn',@ineq_group_SelectionChangeFcn);

set(handles.ineq_group,'SelectedObject',handles.inequality_radio);
set(handles.previous_button,'Enable','Off');

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes quad_constr wait for user response (see UIRESUME)
uiwait(handles.quad_constr);


% --- Outputs from this function are returned to the command line.
function varargout = quad_constr_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
switch handles.mode
    case 'ok'
        %output = getappdata(handles.lin_obj,'output');
        output.n = handles.n_constr;
        output.var_Q = handles.var_Q;
        output.var_r = handles.var_r;
        output.var_c = handles.var_c;
        output.ineqs = handles.ineqs;
        varargout{1} = output;
        close
    case 'reset'
        varargout{1} = 2;
        close        
    case 'cancel'
        varargout{1} = 1;
        close
    otherwise
    uiwait(handles.quad_constr);
end

function ineq_group_SelectionChangeFcn(hObject, eventdata)
 
handles = guidata(hObject); 
 
switch get(eventdata.NewValue,'Tag')   % Get Tag of selected object
    case 'inequality_radio'
      handles.ineqeq = 1;
 
    case 'equality_radio'
      handles.ineqeq = 0;
    otherwise
end
guidata(hObject, handles);


function Q_edit_Callback(hObject, eventdata, handles)

function Q_edit_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function r_edit_Callback(hObject, eventdata, handles)

function r_edit_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function c_edit_Callback(hObject, eventdata, handles)

function c_edit_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function cancel_button_Callback(hObject, eventdata, handles)
handles.mode = 'cancel';
guidata(hObject, handles);
uiresume


function ok_button_Callback(hObject, eventdata, handles)
    error = 0;
    error_msg = '';
    
    var_Q = [];
    var_r = [];
    var_c = [];

    input_Q = get(handles.Q_edit,'String');
    input_r = get(handles.r_edit,'String');
    input_c = get(handles.c_edit,'String');

    if (~isempty(input_Q) || ~isempty(input_r) || ~isempty(input_c))
        [error,error_msg,var_Q,var_r,var_c,n] = check_inputs(hObject);

        if ~error
            if handles.n_constr == 0
                error = 1;
                error_msg = 'Error: You have only defined one constraint. Please press Next to define more.';
            elseif n ~= handles.n_constr
                error = 1;
                error_msg = 'Error: The dimensions of this constraint does not match the dimensions of the previous constraint(s).';
            else
                handles.var_Q(:,:,handles.counter) = var_Q;
                handles.var_r(handles.counter,:) = var_r;
                handles.var_c(handles.counter) = var_c;
                handles.ineqs(1,handles.counter) = handles.ineqeq;
            end
        end
        
        if ~error
            [~,~,idx] = size(handles.var_Q);
            if idx ~= handles.n_constr
                error = 1;
                error_msg = sprintf('Error: You must define %i constraints. Please press Next to define more.',handles.n_constr);
            end
        end

        handles.mode = 'ok';
    else
        if ~isempty(handles.var_Q)
            error = 1;
            error_msg = sprintf('Error: You must define %i constraints.',handles.n_constr);
        else
            if ~strcmp(handles.mode,'reset')
                handles.mode = 'cancel';
            end
        end
    end

    noclose = 1;

    if error
        noclose = 0;
        msgbox(error_msg);
    end

guidata(hObject, handles);
% only close if neccessary (the close command is in the Output Function)
if noclose
uiresume
end

function [error,error_msg,var_Q,var_r,var_c,n] = check_inputs(hObject)
    handles = guidata(hObject);
    
    error = 0;
    error_msg = '';
    
    var_Q = [];
    var_r = [];
    var_c = 0;
    n = 0;

    input_Q = get(handles.Q_edit,'String');
    input_r = get(handles.r_edit,'String');
    input_c = get(handles.c_edit,'String');

    % Validate input for matrix Q
    [error,error_msg,var_Q] = test_vector_input(input_Q,1,'Q');

    % Validate input for vector r
    if (~error)
        [error,error_msg,var_r] = test_vector_input(input_r,0,'r');
    end
    
    % Validate input for scalar c
    if (~error)
        msg = 'Error: c should be given as a scalar number or as a variable which is in the workspace.';
        var_c = str2num(input_c);
        if ~isempty(var_c)
            [rows,cols] = size(var_c);
            if rows ~= 1 || cols ~= 1
                error = 1;
                error_msg = msg;
            end
        else
            try
                var_c = evalin('base',input_c);
            catch exception,
                error = 1;
                error_msg = msg;
            end
            if (~error && ~isa(var_c,'double'))
                error = 1;
                msg = sprintf('Error: %s is not a matrix or vector.', input_c);
                error_msg = msg;
            end
        end
    end

    % Check dimensions
    if (~error)
        n = length(var_r);
        [row_Q,col_Q] = size(var_Q);
        if (row_Q  ~= n || col_Q ~= n )
            error = 1;
            error_msg = 'Error: The matrix and vector dimensions do not match.';
        end
    end
guidata(hObject, handles);

function reset_button_Callback(hObject, eventdata, handles)
    set(handles.Q_edit,'String','');
    set(handles.r_edit,'String','');
    set(handles.c_edit,'String','');
    set(handles.ineq_group,'SelectedObject',handles.inequality_radio);
    handles.counter = 1;
    set(handles.nr_text,'String',sprintf('Constraint nr: %i',handles.counter));
    handles.var_Q = [];
    handles.var_r = [];
    handles.var_c = [];
    handles.ineqs = [];
    handles.n_constr = 0;
    handles.mode = 'reset';
guidata(hObject, handles);


function next_button_Callback(hObject, eventdata, handles)
    error = 0;
    error_msg = '';
    stop = 0;
    
    if ~error
        [error,error_msg,var_Q,var_r,var_c,n] = check_inputs(hObject);
    end
    
    if ~error
        if handles.counter == 1
            try
                handles.var_Q(:,:,1) = var_Q;
                handles.var_r(1,:) = var_r;
                handles.var_c(1) = var_c;
                handles.ineqs(1,1) = handles.ineqeq;
                handles.n_constr = n;
            catch exception
                output = change_dim_msg;
                if output == 1
                    stop = 1;
                else
                    handles.var_Q = var_Q;
                    handles.var_r = var_r;
                    handles.var_c = var_c;
                    handles.ineqs = handles.ineqeq;
                    handles.n_constr = n;
                end
            end
        else
            if n ~= handles.n_constr
                error = 1;
                error_msg = 'Error: The dimensions of this constraint does not match the dimensions of the previous constraint(s).';
            else
                handles.var_Q(:,:,handles.counter) = var_Q;
                handles.var_r(handles.counter,:) = var_r;
                handles.var_c(handles.counter) = var_c;
                handles.ineqs(1,handles.counter) = handles.ineqeq;
            end
        end
    end
    
    if error
        msgbox(error_msg);
    elseif ~stop
        set(handles.previous_button,'Enable','On');
        handles.counter = handles.counter + 1;
        set(handles.nr_text,'String',sprintf('Constraint nr: %i',handles.counter));
        [~,~,idx] = size(handles.var_Q);
        if idx >= handles.counter
            set(handles.Q_edit,'String',matrix2str(handles.var_Q(:,:,handles.counter)));
            set(handles.r_edit,'String',vector2str(handles.var_r(handles.counter,:)));
            set(handles.c_edit,'String',sprintf('%.3f',handles.var_c(handles.counter)));
            if handles.ineqs(handles.counter)
                set(handles.ineq_group,'SelectedObject',handles.inequality_radio);
                handles.ineqeq = 1;
            else
                set(handles.ineq_group,'SelectedObject',handles.equality_radio);
                handles.ineqeq = 0;
            end
        else
            set(handles.Q_edit,'String','');
            set(handles.r_edit,'String','');
            set(handles.c_edit,'String','');
            set(handles.ineq_group,'SelectedObject',handles.inequality_radio);
            handles.ineqeq = 1;
        end
        
        if handles.counter == handles.n_constr
            set(handles.next_button,'Enable','Off');
        end
    end

guidata(hObject, handles);


function previous_button_Callback(hObject, eventdata, handles)
    input_Q = get(handles.Q_edit,'String');
    input_r = get(handles.r_edit,'String');
    input_c = get(handles.c_edit,'String');
    
    error = 0;
    if ~isempty(input_Q) || ~isempty(input_r) || ~isempty(input_c)
        [error,error_msg,var_Q,var_r,var_c,n] = check_inputs(hObject);

        if ~error
            if n ~= handles.n_constr
                error = 1;
                error_msg = 'Error: The dimensions of this constraint does not match the dimensions of the previous constraint(s).';
            else
                handles.var_Q(:,:,handles.counter) = var_Q;
                handles.var_r(handles.counter,:) = var_r;
                handles.var_c(handles.counter) = var_c;
                handles.ineqs(1,handles.counter) = handles.ineqeq;
            end
        end
    end
    
    if error
        msgbox(error_msg);
    else
        handles.counter = handles.counter - 1;
        set(handles.nr_text,'String',sprintf('Constraint nr: %i',handles.counter));
        set(handles.next_button,'Enable','On');
        if handles.counter == 1
            set(handles.previous_button,'Enable','Off');
        end
        
        set(handles.Q_edit,'String',matrix2str(handles.var_Q(:,:,handles.counter)));
        set(handles.r_edit,'String',vector2str(handles.var_r(handles.counter,:)));
        set(handles.c_edit,'String',sprintf('%.3f',handles.var_c(handles.counter)));
        if handles.ineqs(handles.counter)
            set(handles.ineq_group,'SelectedObject',handles.inequality_radio);
            handles.ineqeq = 1;
        else
            set(handles.ineq_group,'SelectedObject',handles.equality_radio);
            handles.ineqeq = 0;
        end
        
    end
guidata(hObject, handles);


function quad_constr_CloseRequestFcn(hObject, eventdata, handles)

%%%CloseReqFCN
if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    handles.mode = 'cancel';
    guidata(hObject, handles);
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end
