function varargout = quadratic_obj(varargin)
% QUADRATIC_OBJ M-file for quadratic_obj.fig
%      QUADRATIC_OBJ, by itself, creates a new QUADRATIC_OBJ or raises the existing
%      singleton*.
%
%      H = QUADRATIC_OBJ returns the handle to a new QUADRATIC_OBJ or the handle to
%      the existing singleton*.
%
%      QUADRATIC_OBJ('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in QUADRATIC_OBJ.M with the given input arguments.
%
%      QUADRATIC_OBJ('Property','Value',...) creates a new QUADRATIC_OBJ or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before quadratic_obj_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to quadratic_obj_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help quadratic_obj

% Last Modified by GUIDE v2.5 08-May-2011 14:57:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @quadratic_obj_OpeningFcn, ...
                   'gui_OutputFcn',  @quadratic_obj_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before quadratic_obj is made visible.
function quadratic_obj_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to quadratic_obj (see VARARGIN)

% Choose default command line output for quadratic_obj
handles.output = hObject;

input_form = varargin{1};
input_matrix = varargin{2};
if ~isempty(input_matrix)
    set(handles.coeffs_matrix_edit,'String',matrix2str(input_matrix));
end

handles.mode = 'nowhere';
handles.form_std = input_form;
handles.coefficients = [];
handles.coeffs_matrix = input_matrix;
handles.coeffs_exp = [];
handles.pos_idx = [];
handles.neg_idx = [];
handles.indexes = [];
handles.exponent = 1;
handles.uniform = 0;

% Update handles structure
guidata(hObject, handles);
%setappdata(handles.figure1, 'output',1);
% UIWAIT makes quadratic_obj wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = quadratic_obj_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
switch handles.mode
    case 'ok'
        output.coefficients = handles.coefficients;
        output.coeffs_matrix = handles.coeffs_matrix;
        output.coeffs_exp = handles.coeffs_exp;
        output.exponent = handles.exponent;
        output.indexes = handles.indexes;
        output.pos_idx = handles.pos_idx;
        output.neg_idx = handles.neg_idx;
        output.n = length(handles.coeffs_matrix);
        output.m = 1;
        output.uniform = handles.uniform;
        varargout{1} = output;
        close
    case 'reset'
        varargout{1} = 2;
        close
    case 'cancel'
        varargout{1} = 1;
        close
        %error('You have quit!!'); This works, but also gives a bunch of
        %other errors. It's better if it is put in the calling function for
        %when output equals 1.
    otherwise
    uiwait(handles.figure1);
end


function coeffs_matrix_edit_Callback(hObject, eventdata, handles)


function coeffs_matrix_edit_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function status_text_Callback(hObject, eventdata, handles)


function status_text_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function cancel_button_Callback(hObject, eventdata, handles)
handles.mode = 'cancel';
guidata(hObject, handles);
uiresume


function ok_button_Callback(hObject, eventdata, handles)
err_ = 0;
err_msg = '';
noclose = 1;
posneg = -1;
input = get(handles.coeffs_matrix_edit,'String');

if ~isempty(input)
    [err_,err_msg,coeffs_matrix] = test_vector_input(input,1,'G');

    if ~err_
        [rows,cols] = size(coeffs_matrix);
        if rows ~= cols
            err_ = 1;
            err_msg = 'Error: The dimensions of G are incorrect. G should be an n-by-n matrix.';
        end
    end

    % Perform checks on data
    if ~err_
        msg_std = 'Error: The elements of G must all be either positive or negative in order to have a strictly increasing objective function.';
        msg_can = 'Error: The elements of G must all be either positive or negative in order to have a strictly decreasing objective function.';
        n = length(coeffs_matrix);
        rows_ok = zeros(1,n);
        cols_ok = zeros(1,n);
        for i = 1:n,
            for j = 1:n,
                val = coeffs_matrix(i,j);
                if (val ~= 0)
                    rows_ok(1,i) = 1;
                    cols_ok(1,j) = 1;
                    if val > 0
                        if posneg == -1, posneg = 1; end
                        if ~posneg
                            err_ = 1;
                            if handles.form_std
                                err_msg = msg_std;
                            else
                                err_msg = msg_can;
                            end
                            break;
                        end
                    else
                        if posneg == -1, posneg = 0; end
                        if posneg
                            err_ = 1;
                            if handles.form_std
                                err_msg = msg_std;
                            else
                                err_msg = msg_can;
                            end
                            break;
                        end
                    end
                end
            end
            if err_, break; end
        end
        if ~err_
            twos = ones(n,1)*2;
            if (rows_ok*twos ~= n*2 && cols_ok*twos ~= n*2)
                err_ = 1;
                err_msg = 'Error: Either each row or each column of G must have at least one non-zero element.';
            end
        end
    end

    if err_
        noclose = 0;
        set(handles.status_text,'String',err_msg);
    else
        if handles.form_std
            if posneg
                handles.pos_idx = 1:n;
                handles.neg_idx = [];
            else
                handles.pos_idx = [];
                handles.neg_idx = 1:n;
            end
        else
            if posneg
                handles.pos_idx = [];
                handles.neg_idx = 1:n;
            else
                handles.pos_idx = 1:n;
                handles.neg_idx = [];
            end
        end
        handles.coeffs_matrix = coeffs_matrix;
    end
    
    handles.mode = 'ok';
else
    if ~isempty(handles.coeffs_matrix)
        handles.mode = 'reset';
    else
        handles.mode = 'cancel';
    end 
end

guidata(hObject, handles);
% only close if neccessary (the close command is in the Output Function)
if noclose
uiresume
end


function figure1_CloseRequestFcn(hObject, eventdata, handles)

%%%CloseReqFCN
if isequal(get(hObject, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    handles.mode = 'cancel';
    guidata(hObject, handles);
    uiresume(hObject);
else
    % The GUI is no longer waiting, just close it
    delete(hObject);
end
