function [x,y,done,func_count] = runfmincon(fhandle,x0,A,b,Aeq,beq,lb,ub,handle_con,tolx,tolfun,tolcon,alg)
    x_ = 0;
    y_ = x0';
    func_count_ = 0;
    
    switch alg
        case 1
            options = optimset('Algorithm','interior-point','outputfcn',@outfun,'TolX',tolx,'TolFun',tolfun,'TolCon',tolcon);
        case 2
            options = optimset('Algorithm','sqp','outputfcn',@outfun,'TolX',tolx,'TolFun',tolfun,'TolCon',tolcon);
        case 3
            options = optimset('Algorithm','active-set','outputfcn',@outfun,'TolX',tolx,'TolFun',tolfun,'TolCon',tolcon);
    end
    
    error = 0;
    try
        [T,~,~,~,output] = evalc('fmincon(@(x) fhandle(x), x0, A, b, Aeq, beq, lb, ub, handle_con, options)');
    catch exception
        error = 1;
    end
    
    if ~error
        if sol_found(T)
            done = 1;
            func_count_ = output.funcCount;
        else
            done = 0;
        end
    else
        done = -1;
    end
    
    x = x_;
    y = y_;
    func_count = func_count_;
    
    function stop = outfun(x,optimValues,state)
        stop = false;
 
        if strcmp(state,'iter')
            y_ = [y_ x'];
            x_ = [x_ optimValues.iteration+1];
        end
    end
end