function [x,y,done,func_count] = runfsolve(fhandle,x0,tolx,tolfun)
    x_ = 0;
    y_ = x0';
    func_count_ = 0;
    
    options = optimset('outputfcn',@outfun,'TolX',tolx,'TolFun',tolfun);
    
    error = 0;
    try
        [T,~,~,~,output] = evalc('fsolve(@(x) fhandle(x), x0,options)');
    catch exception
        error = 1;
    end
    
    if ~error
        check = regexp(T,'Equation solved');

        func_count_ = output.funcCount;
        if (~isempty(check))
            done = 1;
        else
            done = 0;
        end
    else
        done = -1;
    end
    
    x = x_;
    y = y_;
    func_count = func_count_;
    
    function stop = outfun(x,optimValues,state)
        stop = false;
 
        if strcmp(state,'iter')
            y_ = [y_ x'];
            x_ = [x_ optimValues.iteration+1];
        end
    end
end