function f = suggest_function(x,type,coeffs,exponent,indexes,coeffs_matrix,coeffs_exp)
    switch type
        case 1
            f = coeffs*x';
        case 2
            f = (coeffs*x')^exponent;
        case 3
            f = simple_quadratic(x,coeffs,indexes);
        case 4
            f_ = simple_quadratic(x,coeffs,indexes);
            f = f_^exponent;
        case 5
            f = x*coeffs_matrix*x';
        case 6
            f = coeffs*exp(coeffs_exp.*x)';
    end
    
    function f = simple_quadratic(x,coeffs,indexes)
        n = length(coeffs);
        counter = 1;
        f_ = 0;
        for i = n,
            if ~isempty(indexes) && indexes(counter) == i
                f_ = f_ + coeffs(i)*x(i)^2;
                if counter < length(indexes), counter = counter + 1; end
            else
                f_ = f_ + coeffs(i)*x(i);
            end
        end
        f = f_;
    end
end