function [error,error_msg,var] = test_index_input(input,n)
    error = 0;
    error_msg = '';
    var = [];

    if ~isempty(input)
        letters = regexpi(input, '[A-Z]');
        if (~isempty(letters))
            error = 1;
            error_msg = sprintf('Error: The indexes cannot be given by letters, select numbers from 1 to %i.',n);
        else
            split_string = regexp(input, '\,', 'split');
            m = length(split_string);
            v = zeros(1,m);
            last = 0;

            for i = 1:m,
                nr = sscanf(char(split_string(i)),'%f');
                if (length(nr) ~= 1)
                    error = 1;
                    error_msg = 'Error: Each index should be separated by a comma.';
                    break;
                elseif nr > n || nr < 1
                    error = 1;
                    error_msg = sprintf('Error: Index is out of bounds, select numbers from 1 to %i',n);
                    break;
                elseif nr <= last
                    error = 1;
                    error_msg = 'Error: Please state the indexes in descending order and do not give the same index twice.';
                else
                    v(1,i) = nr;
                end
                last = nr;
            end
            var = v;
        end
    end
end